/*  Uttakssystem
 *  Copyright (C) 2000 Sverre Hvammen Johansen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include "gladesrc.h"
#include "gladesig.h"
#include "gladestr.h"

GdkFont *font;

int
main (int argc, char *argv[])
{
  GtkWidget *window1;

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window1 = create_uttakssystem ();
  gtk_widget_show (window1);

  font= gdk_font_load ("-*-*-medium-r-normal--12-*-*-*-m-*-iso8859-1");
  gdk_font_ref (font);

  gtk_main ();
  return 0;
}


void
on_uttakssystem_destroy                (GtkObject       *object,
                                        gpointer         user_data)
{
  exit(0);
}

void
on_regler_map                          (GtkWidget       *widget,
                                        gpointer         user_data)
{
  char s[1000];
  gtk_text_set_point (GTK_TEXT(regler), 0);
  gtk_text_forward_delete (GTK_TEXT(regler), gtk_text_get_length (GTK_TEXT(regler)));
  if(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(sumpoengsystem)))
    {
      sprintf(s,
        "Uttakssystem for Norges representant til VM:\n"
        "\n"
        "1. Summen av oppndde poeng i NM fr et VM bestemmer uttakning til VM\n"
        "\n"
        "2. For spillere som har deltatt tidligere i VM teller ikke poeng oppndd i \n"
        "   NM fr siste deltagelse i VM med for beregning av poengsum\n"
	"%s%s"
        "\n"
        "3. 1. plass i et NM gir %.1f poeng, 2. plass gir %.1f poeng, 3. plass gir\n"
        "   %.1f poeng, 4. plass gir %.1f poeng, 5. plass gir %.1f poeng, 6. plass\n"
	"   gir %.1f poeng, 7. plass gir %.1f poeng,  8. plass gir %.1f poeng, 9. plass\n"
        "   gir %.1f poeng, 10. plass gir %.1f poeng, ellers 0 poeng.\n"
        "\n"
        "4. Dersom flere deler en plass fordeles de poengene spillerene ville\n"
        "   ha ftt ved ulik plassering etter hverandre fra den aktuelle plass\n"
        "   likt mellom spillerene\n"
        "\n"
        "5. Ved poenglikhet avgjres uttakning ved egen turnering mellom de aktuelle spillere\n",
	      gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(halver))?
	      "   Spiller som deltok i VM siste r fr rets poeng halvert.\n":"",
	      gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(reduser))?
	      "   Hvert rs poeng reduseres med en for hvert pflgende r.\n":"",
	      gtk_range_get_adjustment(GTK_RANGE(poeng1))->value,
	      gtk_range_get_adjustment(GTK_RANGE(poeng2))->value,
	      gtk_range_get_adjustment(GTK_RANGE(poeng3))->value,
	      gtk_range_get_adjustment(GTK_RANGE(poeng4))->value,
	      gtk_range_get_adjustment(GTK_RANGE(poeng5))->value,
	      gtk_range_get_adjustment(GTK_RANGE(poeng6))->value,
	      gtk_range_get_adjustment(GTK_RANGE(poeng7))->value,
	      gtk_range_get_adjustment(GTK_RANGE(poeng8))->value,
	      gtk_range_get_adjustment(GTK_RANGE(poeng9))->value,
	      gtk_range_get_adjustment(GTK_RANGE(poeng10))->value);
      gtk_text_insert(GTK_TEXT(regler), NULL, NULL, NULL, s, strlen(s));
    } else
  if(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(poengfratrekssystem)) && 
     gtk_range_get_adjustment(GTK_RANGE(akkumulering))->value==1.0)
    {
      sprintf(s,
        "Uttakssystem for Norges representant til VM:\n"
        "\n"
        "1. Poeng oppndd i NM nrmest fr VM bestemmer uttakning til VM\n"
        "\n"
        "2. Det oppnes ett poeng for hver seier eller walk over i turneringen\n"
        "\n"
        "3. For spillere som har deltatt tidligere i VM blir det gitt et\n"
        "   fratrekk i poengene som er lik:\n"
        "\n"
        "                          %.1f\n"
        "     -------------------------\n"
        "     antall ganger siden siste deltagelse\n"
        "\n"
        "4. Ved poenglikhet avgjres uttakning ved egen turnering mellom de aktuelle\n"
        "   spillere\n",gtk_range_get_adjustment(GTK_RANGE(grunntall))->value);
      gtk_text_insert(GTK_TEXT(regler), NULL, NULL, NULL, s, strlen(s));
    } else
  if(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(poengfratrekssystem)) &&
     gtk_range_get_adjustment(GTK_RANGE(akkumulering))->value==20.0)
    {
      sprintf(s,
        "Uttakssystem for Norges representant til VM:\n"
        "\n"
        "1. Poeng oppndd i NM nrmest fr VM bestemmer uttakning til VM\n"
        "\n"
        "2. Det oppnes ett poeng for hver seier eller walk over i turneringen\n"
        "\n"
        "3. For hver deltagelse i VM blir det gitt et fratrekk p:\n"
        "\n"
        "                          %.1f\n"
        "     ---------------------\n"
        "     antall ganger siden deltagelse\n"
        "\n"
        "4. Ved poenglikhet avgjres uttakning ved egen turnering mellom de aktuelle\n"
        "   spillere\n",gtk_range_get_adjustment(GTK_RANGE(grunntall))->value);
      gtk_text_insert(GTK_TEXT(regler), NULL, NULL, NULL, s, strlen(s));
    } else
  if(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(poengfratrekssystem)))
    {
      sprintf(s,
        "Uttakssystem for Norges representant til VM:\n"
        "\n"
        "1. Poeng oppndd i NM nrmest fr VM bestemmer uttakning til VM\n"
        "\n"
        "2. Det oppnes ett poeng for hver seier eller walk over i turneringen\n"
        "\n"
        "3. For inntil de %.0f. siste deltagelser i VM blir det gitt et fratrekk p:\n"
        "\n"
        "                          %.1f\n"
        "     ---------------------\n"
        "     antall ganger siden deltagelse\n"
        "\n"
        "4. Ved poenglikhet avgjres uttakning ved egen turnering mellom de aktuelle\n"
        "   spillere\n",gtk_range_get_adjustment(GTK_RANGE(akkumulering))->value,
	      gtk_range_get_adjustment(GTK_RANGE(grunntall))->value);
      gtk_text_insert(GTK_TEXT(regler), NULL, NULL, NULL, s, strlen(s));
    } else
  if(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(deltaksfratrekssystem)))
    {
      sprintf(s,
        "Uttakssystem for Norges representant til VM:\n"
        "\n"
        "1. Plassering i NM nrmest fr VM bestemmer uttakning til VM.\n"
        "\n"
        "2. Spillere som ikke har deltatt i et VM senere enn\n"
        "   (2^(Plassering))/(Antall spillere som skal tas ut) VM tidligere gr\n"
        "   forran andre spillere.\n"
        "\n"
        "3. Ved lik plassering avgjres uttakning ved egen turnering mellom de\n"
        "   aktuelle spillere.\n");
      gtk_text_insert(GTK_TEXT(regler), NULL, NULL, NULL, s, strlen(s));
    }

    sprintf(s,
      "\n"
      "Merknader til Simulering:\n"
      "\n"
      "   For simulering anntas det at 1. plass gir 9 seiere i turnering, 2. plass gir 8 seiere i\n"
      "   turnering, 3. plass gir 7 seiere i turnering osv. helt til 10. plass som gir 0 seiere i turnering.\n"
      "\n"
      "   Simulering inneholder ikke fordeling av poeng ved lik plassering. Regimet i forrige avsnitt er benyttet.\n"
      "\n"
      "   Dersom man f.eks. nsker  simulere at 1. plassen fr 2 seiere mer i turneringen enn\n"
      "   andre plassen kan man gi dem henholdsvis 1. og 3. plassering.\n"
      "\n"
      "   Dersom det trengs egen turnering for  avgjre uttakning anntas det at lavest deltagernummer vinner.");

    gtk_text_insert(GTK_TEXT(regler), NULL, NULL, NULL, s, strlen(s));
}

int plassering [11][101];

void set_videre_plassering()
{
  int i,j=1,k;
  for (k=1;k<=10;k++)
    for (i=11;i<=100;i++)
      {
	if(j==11)j=1;
	plassering[k][i]=plassering[k][j];
	j++;
      }
}

void set_plassering_dynamisk()
{
  plassering[1][1]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale0))->value;
  plassering[2][1]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale1))->value;
  plassering[3][1]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale2))->value;
  plassering[4][1]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale3))->value;
  plassering[5][1]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale4))->value;
  plassering[6][1]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale5))->value;
  plassering[7][1]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale6))->value;
  plassering[8][1]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale7))->value;
  plassering[9][1]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale8))->value;
  plassering[10][1]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale9))->value;
  plassering[1][2]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale10))->value;
  plassering[2][2]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale11))->value;
  plassering[3][2]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale12))->value;
  plassering[4][2]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale13))->value;
  plassering[5][2]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale14))->value;
  plassering[6][2]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale15))->value;
  plassering[7][2]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale16))->value;
  plassering[8][2]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale17))->value;
  plassering[9][2]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale18))->value;
  plassering[10][2]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale19))->value;
  plassering[1][3]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale20))->value;
  plassering[2][3]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale21))->value;
  plassering[3][3]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale22))->value;
  plassering[4][3]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale23))->value;
  plassering[5][3]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale24))->value;
  plassering[6][3]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale25))->value;
  plassering[7][3]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale26))->value;
  plassering[8][3]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale27))->value;
  plassering[9][3]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale28))->value;
  plassering[10][3]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale29))->value;
  plassering[1][4]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale30))->value;
  plassering[2][4]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale31))->value;
  plassering[3][4]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale32))->value;
  plassering[4][4]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale33))->value;
  plassering[5][4]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale34))->value;
  plassering[6][4]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale35))->value;
  plassering[7][4]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale36))->value;
  plassering[8][4]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale37))->value;
  plassering[9][4]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale38))->value;
  plassering[10][4]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale39))->value;
  plassering[1][5]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale40))->value;
  plassering[2][5]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale41))->value;
  plassering[3][5]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale42))->value;
  plassering[4][5]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale43))->value;
  plassering[5][5]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale44))->value;
  plassering[6][5]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale45))->value;
  plassering[7][5]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale46))->value;
  plassering[8][5]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale47))->value;
  plassering[9][5]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale48))->value;
  plassering[10][5]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale49))->value;
  plassering[1][6]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale50))->value;
  plassering[2][6]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale51))->value;
  plassering[3][6]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale52))->value;
  plassering[4][6]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale53))->value;
  plassering[5][6]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale54))->value;
  plassering[6][6]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale55))->value;
  plassering[7][6]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale56))->value;
  plassering[8][6]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale57))->value;
  plassering[9][6]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale58))->value;
  plassering[10][6]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale59))->value;
  plassering[1][7]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale60))->value;
  plassering[2][7]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale61))->value;
  plassering[3][7]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale62))->value;
  plassering[4][7]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale63))->value;
  plassering[5][7]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale64))->value;
  plassering[6][7]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale65))->value;
  plassering[7][7]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale66))->value;
  plassering[8][7]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale67))->value;
  plassering[9][7]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale68))->value;
  plassering[10][7]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale69))->value;
  plassering[1][8]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale70))->value;
  plassering[2][8]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale71))->value;
  plassering[3][8]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale72))->value;
  plassering[4][8]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale73))->value;
  plassering[5][8]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale74))->value;
  plassering[6][8]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale75))->value;
  plassering[7][8]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale76))->value;
  plassering[8][8]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale77))->value;
  plassering[9][8]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale78))->value;
  plassering[10][8]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale79))->value;
  plassering[1][9]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale80))->value;
  plassering[2][9]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale81))->value;
  plassering[3][9]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale82))->value;
  plassering[4][9]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale83))->value;
  plassering[5][9]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale84))->value;
  plassering[6][9]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale85))->value;
  plassering[7][9]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale86))->value;
  plassering[8][9]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale87))->value;
  plassering[9][9]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale88))->value;
  plassering[10][9]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale89))->value;
  plassering[1][10]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale90))->value;
  plassering[2][10]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale91))->value;
  plassering[3][10]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale92))->value;
  plassering[4][10]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale93))->value;
  plassering[5][10]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale94))->value;
  plassering[6][10]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale95))->value;
  plassering[7][10]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale96))->value;
  plassering[8][10]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale97))->value;
  plassering[9][10]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale98))->value;
  plassering[10][10]= (int) gtk_range_get_adjustment(GTK_RANGE(hscale99))->value;
}

void set_plassering_statisk()
{
  int i,j;
  for (i=1;i<=10;i++)
    for (j=1;j<=10;j++)
     plassering[i][j]= i;
}

void set_plassering_1og2()
{
  int i;
  set_plassering_statisk();
  for (i=2; i<=10; i+=2)
    {
      plassering[1][i]= 2;
      plassering[2][i]= 1;
    }
}

GtkWidget *res_window;

void simuler_sumpoengsystem(double poeng1,double poeng2,double poeng3,double poeng4,double poeng5,double poeng6,double poeng7,double poeng8,double poeng9,double poeng10, int reduser_poeng, int halver_poeng)
{
  double poeng[101][11];
  int deltager[101];
  int ndeltatt[11];
  int aar, aars_deltager;
  void initialize()
    {
      int i;
      for(i=1;i<=10;i++)ndeltatt[i]=0;
    }
  void reduser(int aar)
    {
      int i, j;
      for (i=1; i<=aar;i++)
	for (j=1;j<=10;j++)
	  if (poeng[i][j]>0.0) poeng[i][j]-=1.0;
    }
  void halver(int aar)
    {
      int i;
      for (i=1;i<=10;i++)
	if (deltager[aar-1]==i) poeng[aar][i]/=2.0;
    }
  void nullut (int aar, int j)
    {
      int i;
      for (i=1;i<=aar;i++) poeng[i][j]=0.0;
    }
  double sum(int aar, int j)
    {
      double s=0.0;
      int i;
      for(i=1;i<=aar;i++)
	s += poeng[i][j];
      return s;
    }

  void delut(int aar)
    {
      int i;
      double p;
      for (i=1;i<=10;i++)
	{
	  switch(plassering[i][aar])
	    {
	    case 1:
	      p=poeng1;
	      break;
	    case 2:
	      p=poeng2;
	      break;
	    case 3:
	      p=poeng3;
	      break;
	    case 4:
	      p=poeng4;
	      break;
	    case 5:
	      p=poeng5;
	      break;
	    case 6:
	      p=poeng6;
	      break;
	    case 7:
	      p=poeng7;
	      break;
	    case 8:
	      p=poeng8;
	      break;
	    case 9:
	      p=poeng9;
	      break;
	    case 10:
	      p=poeng10;
	      break;
	    default:
	      p=0;
	    }
	  poeng[aar][i]=p;
	}
    }

  int finn(int aar)
    {
      int i, d=0, s, m=0;
      for (i=1; i<=10; i++)
	{
	  s=sum(aar,i);
	  if (s>m) 
	    {
	      m=s;
	      d=i;
	    }
	}
      return d;
    }

  void skriv_poeng (int aar)
    {
      int i;
      char s[1000];
      sprintf(s,"%4d ", aar);
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
      for (i=1; i<=10;i++)
	{
	  sprintf(s,"%6.2f%s", sum(aar,i), aars_deltager==i?"*":" ");
	  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
	}
      sprintf(s,"\n");
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
    }
  int i;
  char s[1000];
  initialize();
  sprintf(s,"         1      2      3      4      5      6      7      8      9     10\n");
  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
  for (aar=1;aar<=100;aar++)
    {
      if (reduser_poeng) reduser(aar);
      delut(aar);
      if (halver_poeng) halver(aar);
      aars_deltager=finn(aar);
      if (aar<=7) skriv_poeng(aar);
      nullut(aar, aars_deltager);
      deltager[aar]=aars_deltager;
      ndeltatt[aars_deltager]++;
    }
  
  sprintf(s,"   %%");
  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
  for(i=1;i<=10;i++)
    {
      sprintf(s,"%6d ",ndeltatt[i]);
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
    }      
  sprintf(s,"\nTattut: ");
  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
  for(i=1;i<=33;i++)
    {
      sprintf(s,"%d ", deltager[i]);
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
    }
}

void simuler_poengfratrekssystem(double grunntall, int akumulering)
{
  char s[1000];
  double poeng[11];
  int deltager[101];
  int ndeltatt[11];
  int deltok_sist[11][101];
  int aar;
  int aars_deltager;
  void initialize()
    {
      int i,j;
      for (i=1;i<=10;i++)
	{
	  ndeltatt[i]=0;
	  poeng[i]=0;
	  for (j=1;j<=100;j++)
	    {
	      deltok_sist[i][j]=0;
	    }
	}
	
    }
  void delut (int aar)
    {
      int i,a;
      for (i=1;i<=10;i++)
	{
	  poeng[i]= 10-plassering[i][aar];
	  for(a=1; a<=akumulering;a++)
	    {
	      if (deltok_sist[i][a]>0)
		poeng[i]=poeng[i]-grunntall/(aar-deltok_sist[i][a]);
	      else break;
	    }
	}
    }

  int finn(int aar)
    {

      int i, d;
      d=1;
      for(i=1;i<=10;i++)
	{
	  if (poeng[i]>poeng[d]) d=i;
	}
      return d;
    }

  void skriv_poeng (int aar, int vinner)
    {
      int i;
      sprintf(s,"%4d ",aar);
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
      for (i=1;i<=10;i++)
	{
	  sprintf(s,"%6.2f%s",poeng[i],i==vinner?"*":" ");
	  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
	}
      sprintf(s,"\n");
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
    }
  int i;
  initialize();
  sprintf(s,"         1      2      3      4      5      6      7      8      9     10\n");
  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
  for (aar=1; aar<=100;aar++)
    {
      delut(aar);
      aars_deltager=finn(aar);
      if(aar<=7) skriv_poeng(aar,aars_deltager);
      deltager[aar]=aars_deltager;
      ndeltatt[aars_deltager]=ndeltatt[aars_deltager]+1;
      for (i=ndeltatt[aars_deltager];i>=2;i--)
	deltok_sist[aars_deltager][i]= deltok_sist[aars_deltager][i-1];
      deltok_sist[aars_deltager][1]=aar;
    }
  sprintf(s,"   %%");
  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
  for (i=1; i<=10;i++)
    {
      sprintf(s,"%6d ", ndeltatt[i]);
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
    }
  sprintf(s,"\nTattut: ");
  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
  for (i=1; i<=33;i++)
    {
      sprintf(s,"%d ", deltager[i]);
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
    }
}

  
void simuler_deltaksfratrekssystem()
{
  char s[1000];
  int deltok_sist[11];
  int ndeltatt[11];
  int deltager[101];
  int aar;
  int aars_deltager;
  int pow2(int i)
    {
      int p=1,j;
      for (j=1; j<=i; j++) p*=2;
      return p;
    }
  void initialize()
    {
      int i;
      for (i=1;i<=10;i++)
	{
	  deltok_sist[i]=-999999;
	  ndeltatt[i]= 0;
	}
    }
  int finn(int aar)
    {
      int i, d=1;
      for (d=1;d<=10;d++)
	if (pow2(plassering[d][aar])<=(aar - deltok_sist[d])) break;
      if (d==11)
	{
	  d=1;
	  for (i=2;i<=10;i++)
	    {
	      if (plassering[i][aar]< plassering[d][aar]) d=i;
	    }
	}
      else
      for (i=d+1;i<=10;i++)
	{
	  if (plassering[i][aar]< plassering[d][aar] &&
	      pow2(plassering[i][aar])<=(aar - deltok_sist[i])) d=i;
	}
      return d;
    }
  void skriv_poeng (int aar, int vinner)
    {
      int i;
      sprintf(s,"%4d ",aar);
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
      for (i=1;i<=10;i++)
	{
	  sprintf(s,"%6d%s",plassering[i][aar],i==vinner?"*":" ");
	  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
	}
      sprintf(s,"\n");
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
    }
  int i;
  initialize();
  sprintf(s,"         1      2      3      4      5      6      7      8      9     10\n");
  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
  for (aar=1; aar<=100;aar++)
    {
      aars_deltager=finn(aar);
      if(aar<=7) skriv_poeng(aar,aars_deltager);
      deltager[aar]=aars_deltager;
      ndeltatt[aars_deltager]++;
      deltok_sist[aars_deltager]=aar;
    }
  sprintf(s,"   %%");
  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
  for (i=1; i<=10;i++)
    {
      sprintf(s,"%6d ", ndeltatt[i]);
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
    }
  sprintf(s,"\nTattut: ");
  gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
  for (i=1; i<=33;i++)
    {
      sprintf(s,"%d ", deltager[i]);
      gtk_text_insert(GTK_TEXT(res_window), font, NULL, NULL, s, strlen(s));
    }
}

void
on_resultat_map                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
  int i;
  for (i=1;i<=3;i++)
    {
      switch (i)
	{
	case 1:
	  set_plassering_statisk();
	  res_window=statisk;
	  break;
	case 2:
	  set_plassering_1og2();
	  res_window=enogto;
	  break;
	case 3:
	  set_plassering_dynamisk();
	  res_window=dynamisk;
	  break;
	}
      set_videre_plassering();

      gtk_text_set_point (GTK_TEXT(res_window), 0);
      gtk_text_forward_delete (GTK_TEXT(res_window), gtk_text_get_length (GTK_TEXT(res_window)));
      if(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(sumpoengsystem))) 
	simuler_sumpoengsystem(gtk_range_get_adjustment(GTK_RANGE(poeng1))->value,
			       gtk_range_get_adjustment(GTK_RANGE(poeng2))->value,
			       gtk_range_get_adjustment(GTK_RANGE(poeng3))->value,
			       gtk_range_get_adjustment(GTK_RANGE(poeng4))->value,
			       gtk_range_get_adjustment(GTK_RANGE(poeng5))->value,
			       gtk_range_get_adjustment(GTK_RANGE(poeng6))->value,
			       gtk_range_get_adjustment(GTK_RANGE(poeng7))->value,
			       gtk_range_get_adjustment(GTK_RANGE(poeng8))->value,
			       gtk_range_get_adjustment(GTK_RANGE(poeng9))->value,
			       gtk_range_get_adjustment(GTK_RANGE(poeng10))->value,
			       gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(reduser)),
			       gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(halver)));
      else if(gtk_toggle_button_get_active ((GTK_TOGGLE_BUTTON(poengfratrekssystem))))
	simuler_poengfratrekssystem(gtk_range_get_adjustment(GTK_RANGE(grunntall))->value,
				    (int)gtk_range_get_adjustment(GTK_RANGE(akkumulering))->value);
      else if(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(deltaksfratrekssystem)))
	simuler_deltaksfratrekssystem();
    }
}


